/******************************************************************************
*******************************************************************************

	Bubble Fight EX
	relminator
	http://rel.betterwebber.com


	Sparky class


*******************************************************************************
******************************************************************************/

#include <nds.h>
#include <vector>

#include "EntityContainer.h"
#include "StarFighter.h"


#ifndef SPARKY_H
#define SPARKY_H

//------------------------------------------------------------------------------
//	Sparky Enemy
//------------------------------------------------------------------------------
class Sparky 
{

public:
	friend class SparkyContainer;
	
	Sparky();
	~Sparky();
	void Update();
	
private:
	s32		x;
	s32		y;
	s32		Dx;
	s32		Dy;
	int		Frame;
	int 	Counter;
	bool	Active;

};

//------------------------------------------------------------------------------
//	Sparky Container
//------------------------------------------------------------------------------
class SparkyContainer : public EntityContainer
{	

public:

	SparkyContainer();
    ~SparkyContainer();
    void Init( int Palette, glImage* const Sprites );
    virtual void UpdateEntities();
	virtual void DrawEntities();
	virtual bool Collide( StarFighter &Star );
	virtual void KillAllEntities();
	void Spawn( int _x, int _y );
	
	virtual int NumEntities() 
	{
		return numEntities;
	}
	
private:
	int numEntities;
	
	glImage *Images;
	int ColorTable;
	
	std::vector<Sparky> Sparkys;
	
	
};

#endif // SPARKY_H
